/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Autocorrelation                                                        //
//                                                                         //
//  B. Militzer                                     Berkeley 10-24-21      //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef _AUTOCORRLATION_
#define _AUTOCORRLATION_

inline double Autocorrelation(const Array1 <double> & x, const int m) {
  double s = 0.0;
  int nn = x.Size()-m;
  for(int i=0; i<nn; i++) {
    s += x[i]*x[i+m];
  }
  s /= double(nn);
  return s;
}

// 'm' is delay in steps. Use data from n1 to <n2 only
inline double Autocorrelation(const Array1 <double> & x, const int m, const int n1, const  int n2) { 
  const int n  = n2 - n1; // only consider 'n' points from n1 ... <n2
  double s = 0.0;
  for(int i=n1; i<n2; i++) {
    s += x[i];
  }
  const double av = s / double(n);

  const int nn = n - m;   // drop 'm' additional points
  double c = 0.0;
  for(int i=0; i<nn; i++) {
    c += (x[n1+i]-av)*(x[n1+i+m]-av);
  }
  c /= double(nn);
  return c;
}

#endif // _AUTOCORRLATION_
